#include "TESTERTEST_data.mqh";
#property tester_file "TESTERTEST\\test01.txt";
input int PASS=0;//pass id just for optimization
input string note1="/////////////";//keep similar to the build script!
input string collection_folder="TESTERTEST";//collection folder
input string collection_name="test01.txt";//collection filename
input int shelves_total=10000;//total shelves
input int items_per_shelf=100;//total items per shelf
input int atoms_per_item=120;//atoms per item
input datetime datemark=D'2024.01.01 00:01';//datemark
input string nameofcollection=NULL;//collection name

int OnInit(void)
  {
  //if not in the tester
    if(MQLInfoInteger(MQL_TESTER)==0){
      EventSetMillisecondTimer(44);
      }
  //if not in the tester ends here 
  return(INIT_SUCCEEDED);
  }
  
  
void OnTimer(void)
  {
  if(SymbolIsSynchronized(_Symbol)){
    EventKillTimer();
    /* what happens here , 
       we load the collection 
       and we use the same settings to create one as well
       if the collections are the same 
       then the file integrity is ..
       then the file is okay.
    */
    shelf_collection COLLECTION,LOADED;
    COLLECTION.setup(nameofcollection,shelves_total,items_per_shelf,atoms_per_item,datemark);
    if(LOADED.load(collection_folder,collection_name)){
      Print("Loaded collection");
      if(COLLECTION.is_same(LOADED)){
        Print("Collections are identical");
        }else{
        Print("Collections are different");
        }
      }else{
      Print("cannot load collection");
      }
    ExpertRemove();
    Print("DONE");
    }
  }

double OnTester(){
double rate=0.0;
//load the collection
  shelf_collection LOADED;
  if(LOADED.load(collection_folder,collection_name)){
    rate=ArraySize(LOADED.shelves)*(PASS+1);//just to id what runs
    //unload
    LOADED.reset();
    //zero memory
    ZeroMemory(LOADED);
    }
return(rate);
}

void OnTick(void)
  {
      
  }